#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################

##############s#o#q###################
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.CMFCore.utils import getToolByName, ToolInit
from StringIO import StringIO

from Products.QuotaAW.config import *

from StringIO import StringIO

def install_tools(self, out):
    if not hasattr(self, "quota_tool"):
        addTool = self.manage_addProduct['QuotaAW'].manage_addTool(type="Quota Tool")
        print >>out, "Install Tool okay"
    else:
        print >>out, "Tool already exists."
        

def install_actions(self, out):
    at = getToolByName(self, "portal_actions")
    at.manage_aproviders('quota_tool', add_provider=1)
   
def addQuotaAWSlot(self,out):
    # add QuotaAW portlet
    
    slot = "here/portlet_quota/macros/portlet"

    left_slots=getattr(self,'left_slots', None)
    right_slots=getattr(self, 'right_slots', ())

    if left_slots != None:
        if slot not in left_slots and slot not in right_slots:
            left_slots=list(left_slots)+[slot,]
            self.left_slots=left_slots
            print >> out, 'Added QuotaAW portlet to left_slots property.\n'

def install(self):

    out = StringIO()

    install_tools(self, out)
    install_actions(self, out)
    install_subskin(self, out, GLOBALS)
    
    installTypes(self, out,
                 listTypes(PROJECTNAME),
                 PROJECTNAME)

    #portal = getToolByName(self, 'portal_url').getPortalObject()
    #if not hasattr(portal, 'OBJECT_CSS_CONTENT'):
    #        #portal.propertysheets.manage_addProperty('OBJECT_CSS_CONTENT', [], 'lines', REQUEST=None)
    #        portal._setProperty('OBJECT_CSS_CONTENT', [], 'lines')
    #    

    addQuotaAWSlot(self,out)
    return out.getvalue()

#
# Uninstall methods
#

def unregisterActionProvider(self, out):
    actionTool = getToolByName(self, 'portal_actions', None)
    if actionTool:
        actionTool.deleteActionProvider('quota_tool')
        out.write('Removed action provider\n')

# The uninstall is used by the CMFQuickInstaller for uninstalling.
# CMFQuickInstaller uninstalls skins.
def uninstall(self):
    out=StringIO()
    unregisterActionProvider(self, out)
    return out.getvalue()


